interface Category {
    catname: string;
    catdescription: string;
}
interface Bill {
    categoryCode: string;
    billName: string;
    billDescription: string;
    billPriceSetting: number;
    billPayorInfo: number;
    billAmount: number;
    billReturnUrl: string;
    billCallbackUrl: string;
    billExternalReferenceNo: string;
    billTo: string;
    billEmail: string;
    billPhone: string;
    billSplitPayment: number;
    billSplitPaymentArgs: any;
    billPaymentChannel?: number;
}
interface CategoryResult {
    CategoryCode: string;
}
interface BillResult {
    BillCode: string;
}
interface BillTransactionsResult {
    billpaymentStatus: string;
    billpaymentAmount: string;
    billpaymentInvoiceNo: string;
}
declare class ToyyibPay {
    uri: string;
    userSecretKey: string;
    constructor(uri: string, userSecretKey: string);
    /**
    * create a bill category
    * @param catname: string
    * @param catdescription: string
    * @return {"CategoryCode":"j0tzqhka"}
    */
    createCategory(category: Category): Promise<CategoryResult>;
    /**
    * create a bill
    * @return {"BillCode":"j0tzqhka"}
    */
    createBill(bill: Bill): Promise<BillResult>;
    /**
    * get all bill transactions
    */
    getBillTransactions(billCode: string, billExternalReferenceNo: string): Promise<BillTransactionsResult[]>;
}
export default ToyyibPay;
