"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const qs_1 = __importDefault(require("qs"));
class ToyyibPay {
    constructor(uri, userSecretKey) {
        this.uri = uri;
        this.userSecretKey = userSecretKey;
    }
    /**
    * create a bill category
    * @param catname: string
    * @param catdescription: string
    * @return {"CategoryCode":"j0tzqhka"}
    */
    createCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield axios_1.default({
                method: 'POST',
                url: this.uri + '/createCategory',
                data: qs_1.default.stringify(Object.assign({ userSecretKey: this.userSecretKey }, category)),
            });
            return result.data[0];
        });
    }
    /**
    * create a bill
    * @return {"BillCode":"j0tzqhka"}
    */
    createBill(bill) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield axios_1.default({
                method: 'POST',
                url: this.uri + '/createBill',
                data: qs_1.default.stringify(Object.assign({ userSecretKey: this.userSecretKey }, bill)),
            });
            return result.data[0];
        });
    }
    /**
    * get all bill transactions
    */
    getBillTransactions(billCode, billExternalReferenceNo) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = yield axios_1.default({
                method: 'POST',
                url: this.uri + '/getBillTransactions',
                data: qs_1.default.stringify({ billCode, billExternalReferenceNo }),
            });
            return results.data;
        });
    }
}
exports.default = ToyyibPay;
